Halide 22.0.0 Halide compiler and libraries

Loading...
Searching...
No Matches
Classes | Public Member Functions | Static Public Attributes | List of all members
Halide::Internal::IRMatcher::WildConstUInt< i > Struct Template Reference

`#include <IRMatch.h>`

## Classes
struct | pattern_tag

## Public Member Functions
template<uint32_t bound>
HALIDE_ALWAYS_INLINE bool | match (const BaseExprNode &e, MatcherState &state) const noexcept
HALIDE_ALWAYS_INLINE Expr | make (MatcherState &state, halide_type_t type_hint) const
HALIDE_ALWAYS_INLINE void | make_folded_const (halide_scalar_value_t &val, halide_type_t &ty, MatcherState &state) const noexcept

## Static Public Attributes
static constexpr uint32_t | binds = 1 << i
static constexpr IRNodeType | min_node_type = IRNodeType::UIntImm
static constexpr IRNodeType | max_node_type = IRNodeType::UIntImm
static constexpr bool | canonical = true
static constexpr bool | foldable = true

## Detailed Description

template<int i>
struct Halide::Internal::IRMatcher::WildConstUInt< i >

Definition at line 289 of file IRMatch.h.

## Member Function Documentation

## ◆ match()

template<int i>
template<uint32_t bound>

HALIDE_ALWAYS_INLINE bool Halide::Internal::IRMatcher::WildConstUInt< i >::match | ( | const BaseExprNode & | e,
|  | MatcherState & | state
| ) |  | const
| inline noexcept

Definition at line 299 of file IRMatch.h.

References Halide::Internal::IRMatcher::WildConstUInt< i >::binds, Halide::Internal::Broadcast, Halide::Internal::IRMatcher::cast(), Halide::Internal::IRMatcher::max_wild, Halide::Internal::IRNode::node_type, halide_scalar_value_t::u, halide_scalar_value_t::u64, and Halide::Internal::UIntImm.

## ◆ make()

template<int i>

HALIDE_ALWAYS_INLINE Expr Halide::Internal::IRMatcher::WildConstUInt< i >::make | ( | MatcherState & | state,
|  | halide_type_t | type_hint
| ) |  | const
| inline

Definition at line 320 of file IRMatch.h.

References Halide::Internal::IRMatcher::cast(), Halide::Internal::IRMatcher::MatcherState::get_bound_const(), and Halide::Internal::IRMatcher::make_const_expr().

## ◆ make_folded_const()

template<int i>

HALIDE_ALWAYS_INLINE void Halide::Internal::IRMatcher::WildConstUInt< i >::make_folded_const | ( | halide_scalar_value_t & | val,
|  | halide_type_t & | ty,
|  | MatcherState & | state
| ) |  | const
| inline noexcept

Definition at line 330 of file IRMatch.h.

References Halide::Internal::IRMatcher::cast().

## Member Data Documentation

## ◆ binds

template<int i>

constexpr uint32_t Halide::Internal::IRMatcher::WildConstUInt< i >::binds = 1 << i
| static constexpr

Definition at line 292 of file IRMatch.h.

Referenced by Halide::Internal::IRMatcher::WildConstUInt< i >::match().

## ◆ min_node_type

template<int i>

constexpr IRNodeType Halide::Internal::IRMatcher::WildConstUInt< i >::min_node_type = IRNodeType::UIntImm
| static constexpr

Definition at line 294 of file IRMatch.h.

## ◆ max_node_type

template<int i>

constexpr IRNodeType Halide::Internal::IRMatcher::WildConstUInt< i >::max_node_type = IRNodeType::UIntImm
| static constexpr

Definition at line 295 of file IRMatch.h.

## ◆ canonical

template<int i>

constexpr bool Halide::Internal::IRMatcher::WildConstUInt< i >::canonical = true
| static constexpr

Definition at line 296 of file IRMatch.h.

## ◆ foldable

template<int i>

constexpr bool Halide::Internal::IRMatcher::WildConstUInt< i >::foldable = true
| static constexpr

Definition at line 327 of file IRMatch.h.

The documentation for this struct was generated from the following file:

- src/IRMatch.h